# Autosubmit API

[![codecov](https://codecov.io/gh/BSC-ES/autosubmit-api/graph/badge.svg?token=ECJKA4M6GR)](https://codecov.io/gh/BSC-ES/autosubmit-api)
![PyPI - Downloads](https://img.shields.io/pypi/dm/autosubmit-api)
![GitHub Actions Workflow Status](https://img.shields.io/github/actions/workflow/status/BSC-ES/autosubmit-api/ci.yml)


# Table of Contents

1. [Overview](#overview)
2. [Installation](#installation)
3. [Configuration options](#configuration-options)
4. [How to run tests](#how-to-run-tests)

## Overview

Autosubmit API is a package that consumes the information generated by Autosubmit and serves it as an API.

Distribution: https://pypi.org/project/autosubmit-api/

Full documentation: https://autosubmit-api.readthedocs.io/

## Installation

Autosubmit API can be easily installed via pip

```sh
pip install autosubmit-api # >=4.0 (recommended)

# Check installation and serving options
autosubmit_api start -h
```

Start the server:

```sh
autosubmit_api start
```

## Configuration options

The Autosubmit API have some configuration options that can be modified by setting their specific environment variable before starting the server. Here are some options:

- **`SECRET_KEY`**: The secret key to encode the JWT tokens from the Authorization Module. **Important to be set up on production.**
- **`AS_API_ROOT_PATH`**: The root path of the API. This is useful if you are serving it with a reverse proxy. Default is an empty string.

To see the full list go to: https://autosubmit-api.readthedocs.io/en/latest/configuration/

## How to run tests

### Install pytest

```bash
pip install -e .[test]
```

### Run tests:

```bash
pytest
```

You will find the coverage report in `htmlcov/index.html`
